=== debian/changelog ===
eigen3 (3.3.7-2) unstable; urgency=medium

  * [56f108b] Fix some GCC-warnings. (Closes: #952801)
  * [11b3bac] Set compat-level to 12
  * [a184b0e] Set Sstandards-Version to 4.5.0
  * [a4addba] Wrap long lines in changelog entries: 3.3~alpha1-3.

 -- Anton Gladky <gladk@debian.org>  Sat, 29 Feb 2020 18:53:00 +0100

eigen3 (3.3.7-1) unstable; urgency=medium

  * Upload to unstable

 -- Anton Gladky <gladk@debian.org>  Fri, 21 Dec 2018 19:44:10 +0100

eigen3 (3.3.7-1~exp1) experimental; urgency=medium

  [ Jelmer Vernooĳ ]
  * [27ed944] Trim trailing whitespace.

  [ Anton Gladky ]
  * [373088c] Refresh patches
  * [0871c29] Update upstream changelog
  * [385c122] New upstream version 3.3.7

 -- Anton Gladky <gladk@debian.org>  Thu, 20 Dec 2018 23:01:41 +0100

eigen3 (3.3.5-2) unstable; urgency=medium

  [ Gael Guennebaud ]
  * [5820a6b] Fix prototype. (Closes: #908336)

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Sep 2018 09:39:48 +0200

eigen3 (3.3.5-1) unstable; urgency=medium

  [ Jochen Sprickerhof ]
  * [8948b47] suggest libmpfrc++-dev instead of libmrpt-dev (Closes: #906126)

  [ Andreas Tille ]
  * [909ca02] New upstream version 3.3.5. (Closes: #905842, #898249)
  * [fcae7a1] Point Vcs fields to salsa.debian.org

  [ Anton Gladky ]
  * [8611869] Refresh patches
  * [05b20c6] Update upstream changelog
  * [337f979] Standards-Version: 4.2.1
  * [9a814e1] Fix typo in patch.
  * [b1c9cad] Fix path in doc-base.

 -- Anton Gladky <gladk@debian.org>  Sat, 01 Sep 2018 22:14:49 +0200
