=== debian/control ===
Source: eigen3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: libdevel
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
               gfortran,
               pkg-config
Build-Depends-Indep: doxygen-latex,
                     ghostscript,
                     graphviz,
                     libjs-jquery,
                     fonts-freefont-ttf
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/eigen3
Vcs-Git: https://salsa.debian.org/science-team/eigen3.git
Homepage: http://eigen.tuxfamily.org

Package: libeigen3-dev
Architecture: all
Multi-Arch: foreign
Depends: pkg-config,
         ${misc:Depends}
Suggests: libeigen3-doc,
          libmpfrc++-dev
Description: lightweight C++ template library for linear algebra
 Eigen 3 is a lightweight C++ template library for vector and matrix math,
 a.k.a. linear algebra.
 .
 Unlike most other linear algebra libraries, Eigen 3 focuses on the simple
 mathematical needs of applications: games and other OpenGL apps, spreadsheets
 and other office apps, etc. Eigen 3 is dedicated to providing optimal speed
 with GCC. A lot of improvements since 2-nd version of Eigen.

Package: libeigen3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-jquery,
         fonts-freefont-ttf,
         ${misc:Depends}
Suggests: libeigen3-dev
Description: eigen3 API documentation
 Eigen 3 is a lightweight C++ template library for vector and matrix math,
 a.k.a. linear algebra.
 .
 This package provides the complete eigen3 API documentation in HTML format.
