=== debian/changelog ===
eigen3 (3.3.9-2) unstable; urgency=medium

  * [9373c6b] Use libjs-mathjax
  * [6576fd5] Set Standards-version to 4.5.1
  * [e5dc6d7] Remove lintian-overrides
  * [37cb945] Install examples
  * [b2f68e5] Use compat-level 13

 -- Anton Gladky <gladk@debian.org>  Mon, 25 Jan 2021 19:01:29 +0100

eigen3 (3.3.9-1) unstable; urgency=medium

  * [17ec168] New upstream version 3.3.9
  * [43a3013] Refresh patches
  * [358d783] Ignore quilt dir
  * [9e3f985] Set upstream metadata fields: Repository, Repository-Browse.
  * [96ce63b] Update upstream changelog

 -- Anton Gladky <gladk@debian.org>  Sun, 06 Dec 2020 13:36:42 +0100

eigen3 (3.3.8-3) unstable; urgency=medium

  * [e301e0d] Remove error counting in OpenMP parallelize_gemm.
              (Closes: #972105)

 -- Anton Gladky <gladk@debian.org>  Tue, 13 Oct 2020 20:35:44 +0200

eigen3 (3.3.8-2) unstable; urgency=medium

  * [74ccd40] Fix FTBFS due to wrong FindEigen3 path

 -- Anton Gladky <gladk@debian.org>  Fri, 09 Oct 2020 23:11:07 +0200

eigen3 (3.3.8-1) unstable; urgency=medium

  * [793848a] Update d/watch
  * [2772ab0] New upstream version 3.3.8
  * [e2f5f88] Refresh patches
  * [d44d451] Set upstream metadata fields: Bug-Database, Bug-Submit.
  * [310f7be] Update upstream changelog

 -- Anton Gladky <gladk@debian.org>  Mon, 05 Oct 2020 23:20:20 +0200

eigen3 (3.3.8~rc1-1~exp1) experimental; urgency=medium

  [ Aron Xu ]
  * [59d4107] Allow parallel build and tests

  [ Anton Gladky ]
  * [dc8e7b6] New upstream version 3.3.8~rc1
  * [0bd8149] Refresh patches
  * [5fe2b0e] Add debian/.gitlab-ci.yml

 -- Anton Gladky <gladk@debian.org>  Sat, 26 Sep 2020 09:16:48 +0200

eigen3 (3.3.7-3) unstable; urgency=medium

  * [870d34a] Fix FTBFS with GCC-10. (Closes: #966871)

 -- Anton Gladky <gladk@debian.org>  Fri, 14 Aug 2020 22:22:42 +0200
