=== debian/control ===
--- 
+++ 
@@ -4,15 +4,16 @@
 Section: libdevel
 Priority: optional
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                gfortran,
                pkg-config
 Build-Depends-Indep: doxygen-latex,
                      ghostscript,
                      graphviz,
                      libjs-jquery,
+                     libjs-mathjax,
                      fonts-freefont-ttf
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/eigen3
 Vcs-Git: https://salsa.debian.org/science-team/eigen3.git
 Homepage: http://eigen.tuxfamily.org
@@ -38,6 +39,7 @@
 Multi-Arch: foreign
 Section: doc
 Depends: libjs-jquery,
+         libjs-mathjax,
          fonts-freefont-ttf,
          ${misc:Depends}
 Suggests: libeigen3-dev
