=== debian/tests/control ===
Tests: build1
Depends: libeigen3-dev, build-essential
